Codeforces Contest 1101 problem G (Zero XOR Subset)-less —— 线性基

2024-04-07 00:32

本文主要是介绍Codeforces Contest 1101 problem G (Zero XOR Subset)-less —— 线性基,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

You are given an array a1,a2,…,an of integer numbers.

Your task is to divide the array into the maximum number of segments in such a way that:

each element is contained in exactly one segment;
each segment contains at least one element;
there doesn’t exist a non-empty subset of segments such that bitwise XOR of the numbers from them is equal to 0.
Print the maximum number of segments the array can be divided into. Print -1 if no suitable division exists.

Input
The first line contains a single integer n (1≤n≤2⋅105) — the size of the array.

The second line contains n integers a1,a2,…,an (0≤ai≤109).

Output
Print the maximum number of segments the array can be divided into while following the given constraints. Print -1 if no suitable division exists.

Examples
inputCopy
4
5 5 7 2
outputCopy
2
inputCopy
3
1 2 3
outputCopy
-1
inputCopy
3
3 1 10
outputCopy
3
Note
In the first example 2 is the maximum number. If you divide the array into {[5],[5,7,2]}, the XOR value of the subset of only the second segment is 5⊕7⊕2=0. {[5,5],[7,2]} has the value of the subset of only the first segment being 5⊕5=0. However, {[5,5,7],[2]} will lead to subsets {[5,5,7]} of XOR 7, {[2]} of XOR 2 and {[5,5,7],[2]} of XOR 5⊕5⊕7⊕2=5.

Let’s take a look at some division on 3 segments — {[5],[5,7],[2]}. It will produce subsets:

{[5]}, XOR 5;
{[5,7]}, XOR 2;
{[5],[5,7]}, XOR 7;
{[2]}, XOR 2;
{[5],[2]}, XOR 7;
{[5,7],[2]}, XOR 0;
{[5],[5,7],[2]}, XOR 5;
As you can see, subset {[5,7],[2]} has its XOR equal to 0, which is unacceptable. You can check that for other divisions of size 3 or 4, non-empty subset with 0 XOR always exists.

The second example has no suitable divisions.

The third example array can be divided into {[3],[1],[10]}. No subset of these segments has its XOR equal to 0.

题意:

给你n个数,让你分成尽可能多的集合,使得任意集合的异或不为0

题解:

第一次遇到线性基的题目,这道题就是求线性无关的秩
别人的模板

#include<bits/stdc++.h>
using namespace std;
int a[35];
int main()
{int n;scanf("%d",&n);int ans=0,ret=0;for(int i=1;i<=n;i++){int x;scanf("%d",&x);ret^=x;for(int j=31;j>=0;j--){if((x&(1<<j))){if(a[j])x^=a[j];else{a[j]=x,ans++;break;}}}}printf("%d\n",ret==0?-1:ans);return 0;
}

这篇关于Codeforces Contest 1101 problem G (Zero XOR Subset)-less —— 线性基的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/881227

相关文章

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

uva 10025 The ? 1 ? 2 ? ... ? n = k problem(数学)

题意是    ?  1  ?  2  ?  ...  ?  n = k 式子中给k,? 处可以填 + 也可以填 - ,问最小满足条件的n。 e.g k = 12  - 1 + 2 + 3 + 4 + 5 + 6 - 7 = 12 with n = 7。 先给证明,令 S(n) = 1 + 2 + 3 + 4 + 5 + .... + n 暴搜n,搜出当 S(n) >=

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

2014 Multi-University Training Contest 8小记

1002 计算几何 最大的速度才可能拥有无限的面积。 最大的速度的点 求凸包, 凸包上的点( 注意不是端点 ) 才拥有无限的面积 注意 :  凸包上如果有重点则不满足。 另外最大的速度为0也不行的。 int cmp(double x){if(fabs(x) < 1e-8) return 0 ;if(x > 0) return 1 ;return -1 ;}struct poin

2014 Multi-University Training Contest 7小记

1003   数学 , 先暴力再解方程。 在b进制下是个2 , 3 位数的 大概是10000进制以上 。这部分解方程 2-10000 直接暴力 typedef long long LL ;LL n ;int ok(int b){LL m = n ;int c ;while(m){c = m % b ;if(c == 3 || c == 4 || c == 5 ||

2014 Multi-University Training Contest 6小记

1003  贪心 对于111...10....000 这样的序列,  a 为1的个数,b为0的个数,易得当 x= a / (a + b) 时 f最小。 讲串分成若干段  1..10..0   ,  1..10..0 ,  要满足x非递减 。  对于 xi > xi+1  这样的合并 即可。 const int maxn = 100008 ;struct Node{int